##
##  TCL Interface: packing function (pack_it_all) in procedures.tcl
##
##  There is a bodge in here to stop the unwanted highlighting of
##  the contents of text widgets after double-clicking the mouse
##  in it. i.e. provide:
##
##    -selectbackground <text_widget_background_colour>
##    -selectborderwidth 0
##
##  as attributes of the widget.


proc gui {} {
	global logfile
	global lgf

	global full_title
	global intro_query_terms_title

  global header_label
	global intro_label

	global installation_root_label
	global bss_parmpath_label
	global bib_dir_label
	global exchange_format_path_label
	global exchange_format_name_label

	global installation_root
	global bss_parmpath

	global exchange_format_path
	global exchange_format_filename

	global db_name_label
	global display_name_label
	global db_type_label
	global nf_label
	global ni_label

	global db_name
	global lastbibvol
	global bib_basename
	global bib_dir
	global bibsize
	global real_bibsize

	global display_name
	global explanation

	global nr

	global nf
	global field_abbrev
	global field_type

	global rec_mult
	global fixed
	global db_type
	global has_lims
	global maxreclen

	global ni

	##  parameter files index arrays

	global last_ixvol
	global ix_stem
	global ix_volsize
	global ix_type

	global max_fields
	global max_indexes

	global index_name
	global field_list
	global kw
	global gsl_file
	global stem_fcn

	global menu_name
	global menu_x
	global menu_y

  . configure -bg grey95
  . configure -cursor left_ptr 

  set menu_name ".indexing_menu"

  wm title . $full_title

	wm geometry . 900x500+100+200

	set header_label $intro_label

	frame .upper \
			-borderwidth 10 \
			-bg Grey95

	frame .lower \
			-width 800 \
			-height 77 \
			-borderwidth 10 \
			-bg Grey95
	
  frame .top_header_frame \
			-relief groove \
			-bg LightGrey \
			-bd 1 \
			-width 200
	
  label .top_header_label \
			-relief groove \
			-width 200 \
			-bg Grey90 \
			-fg black \
			-text $header_label
	
	##  1. Intro screen widgets

	frame .intro_text_frame \
			-bg grey95 \
			-borderwidth 10

  text .intro_text \
			-wrap "word" \
			-width 30 \
			-height 20 \
			-relief groove \
			-bg White \
			-selectbackground white \
			-selectborderwidth 0 \
			-fg Black \
			-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-* \
			-yscrollcommand ".intro_text_vscroll set"

  scrollbar .intro_text_vscroll \
			-command ".intro_text yview" \
			-bg Lightgrey \
			-troughcolor SlateGrey \
			-highlightcolor LightGoldenRodYellow

	##  2. db_parameters_screen_1 widgets

	foreach p1 { root parmp bibf exch } {
		frame .paths_$p1 \
			-bg grey95 \
			-borderwidth 10

		if { $p1 == "root" } {
			set entry_label $installation_root_label
		} elseif { $p1 == "parmp" } {
			set entry_label $bss_parmpath_label
		} elseif { $p1 == "bibf" } {
			set entry_label $bib_dir_label
		} elseif { $p1 == "exch" } {
			set entry_label $exchange_format_path_label
		}

		label .paths_$p1.field_label \
			-text $entry_label \
			-bg Grey95 \
			-padx 0 \
			-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*
	
		if { $p1 == "root" } {
			entry .paths_$p1.entry_box \
					-relief sunken \
					-width 100 \
					-bg White \
					-fg red \
					-textvariable installation_root \
					-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*

		} elseif { $p1 == "parmp" } {
			entry .paths_$p1.entry_box \
					-relief sunken \
					-width 100 \
					-bg White \
					-fg red \
					-textvariable bss_parmpath \
					-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*
		} elseif { $p1 == "bibf" } {
			entry .paths_$p1.entry_box \
					-relief sunken \
					-width 100 \
					-bg White \
					-fg red \
					-textvariable bib_dir \
					-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*
		} elseif { $p1 == "exch" } {
			entry .paths_$p1.entry_box \
					-relief sunken \
					-width 100 \
					-bg White \
					-fg red \
					-textvariable exchange_format_path \
					-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*
		}
	}

	##  3. db_parameters_screen_2 widgets

	foreach p2 { exch dname dtype desc nf ni } {
		frame .dbinfo_$p2 \
			-bg grey95 \
			-borderwidth 5

		if { $p2 == "exch" } {

			button .dbinfo_$p2.button_$p2 \
					-text "" \
					-relief raised \
					-bg grey95 \
					-activebackground LightGoldenRodYellow \
					-command "post_menu $menu_name.set_exch_fname $menu_x $menu_y"
			
			bind .dbinfo_$p2.button_$p2 <Button-1> {
				determine_coords %W
			}

			label .dbinfo_$p2.field_label \
					-text $exchange_format_name_label \
					-bg Grey95 \
					-padx 0
			
			entry .dbinfo_$p2.entry_box \
					-relief sunken \
					-width 100 \
					-bg White \
					-fg red \
					-textvariable exchange_format_filename \
					-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*

		} elseif { $p2 == "dname" } {

			button .dbinfo_$p2.button_$p2 \
					-text "" \
					-relief raised \
					-bg grey95 \
					-activebackground LightGoldenRodYellow \
					-command "post_menu $menu_name.set_db_fname $menu_x $menu_y"
			
			bind .dbinfo_$p2.button_$p2 <Button-1> {
				determine_coords %W
			}

			label .dbinfo_$p2.field_label \
					-text $db_name_label \
					-bg Grey95 \
					-padx 0
			
			entry .dbinfo_$p2.entry_box \
					-relief sunken \
					-width 100 \
					-bg White \
					-fg red \
					-textvariable db_name \
					-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*


		} elseif { $p2 == "dtype" } {

			button .dbinfo_$p2.button_$p2 \
					-text "" \
					-relief raised \
					-bg grey95 \
					-activebackground LightGoldenRodYellow \
					-command "post_menu $menu_name.set_dbtype $menu_x $menu_y"
			
			bind .dbinfo_$p2.button_$p2 <Button-1> {
				determine_coords %W
			}

			label .dbinfo_$p2.field_label \
					-text $db_type_label \
					-bg Grey95 \
					-padx 0
			
			entry .dbinfo_$p2.entry_box \
					-relief sunken \
					-width 100 \
					-bg White \
					-fg red \
					-textvariable db_type \
					-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*

		} elseif { $p2 == "desc" } {

			label .dbinfo_$p2.field_label \
					-text $display_name_label \
					-bg Grey95 \
					-padx 0
			
			entry .dbinfo_$p2.entry_box \
					-relief sunken \
					-width 100 \
					-bg White \
					-fg red \
					-textvariable display_name \
					-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*

		} elseif { $p2 == "nf" } {

			label .dbinfo_$p2.field_label \
					-text $nf_label \
					-bg Grey95 \
					-padx 0
			
			entry .dbinfo_$p2.entry_box \
					-relief sunken \
					-width 100 \
					-bg White \
					-fg red \
					-textvariable nf \
					-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*

		} elseif { $p2 == "ni" } {

			label .dbinfo_$p2.field_label \
					-text $ni_label \
					-bg Grey95 \
					-padx 0
			
			entry .dbinfo_$p2.entry_box \
					-relief sunken \
					-width 100 \
					-bg White \
					-fg red \
					-textvariable ni \
					-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*

		} else {
			set entry_label "Unknown"
		}
	}

	##  4. field_entry_screen widgets (max_fields set in ~/.indexing_rc).

	for { set field_no 0 } { $field_no < $max_fields } { incr field_no 1 } {

		set next_field [ expr $field_no + 1 ]

		set field_abbrev($next_field) ""
		set field_type($next_field) "TEXT"

		frame .fields_$next_field \
				-bg grey95 \
				-borderwidth 4
	
		button .fields_$next_field.field_type_$next_field \
				-text "" \
				-relief raised \
				-bg grey95 \
				-activebackground LightGoldenRodYellow \
				-command "post_menu $menu_name.set_ftype $menu_x $menu_y"
		
		bind .fields_$next_field.field_type_$next_field <Button-1> {
			set_array_index %W
			determine_coords %W
		}

		# create a label for the field abbreviation entry box
		
		label .fields_$next_field.1_$next_field \
				-text "Field abbrevn. $next_field:" \
				-bg grey95 \
				-padx 0
		
		entry .fields_$next_field.field_abbrev_$next_field \
				-relief sunken \
				-bg white \
				-fg red \
				-textvariable field_abbrev($next_field) \
				-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*
		
		label .fields_$next_field.2_$next_field \
				-text "Type:" \
				-bg grey95 \
				-padx 0
		
		entry .fields_$next_field.field_type_entry_$next_field \
				-bg white \
				-fg red \
				-relief sunken \
				-textvariable field_type($next_field) \
				-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*
	}

	##  5. index_entry_screen widgets (assume a max of 10 indexes).
	
	for { set index_no 0 } {$index_no < $max_indexes } { incr index_no 1 } {
		# create a frame for buttons and entry
		
		set ix [ expr $index_no + 1 ]
		
		set	index_name($ix) ""
		set field_list($ix) ""
		set kw($ix) "words3"
		set gsl_file($ix) "gsl.inspec"
		set stem_fcn($ix) "wstem"

		set last_ixvol($ix) 0
		set ix_stem($ix) "$bib_dir/$db_name"
		set ix_volsize($ix) 2047
		set ix_type($ix) 9

		frame .indexes_$ix \
				-bg grey95 \
				-borderwidth 4
		
		button .indexes_$ix.index_kw_$ix \
				-text "" \
				-relief raised \
				-bg grey95 \
				-activebackground LightGoldenRodYellow \
				-command "post_menu $menu_name.kw $menu_x $menu_y"
		
		bind .indexes_$ix.index_kw_$ix <Button-1> {
			set_array_index %W
			determine_coords %W
		}


		button .indexes_$ix.index_gsl_$ix \
				-text "" \
				-bg grey95 \
				-activebackground LightGoldenRodYellow \
				-command  "post_menu $menu_name.gsl $menu_x $menu_y"
		
		bind .indexes_$ix.index_gsl_$ix <Button-1> {
			set_array_index %W
			determine_coords %W
		}

		button .indexes_$ix.index_stemf_$ix \
				-text "" \
				-bg grey95 \
				-activebackground LightGoldenRodYellow \
				-command  "post_menu $menu_name.stem $menu_x $menu_y"
		
		bind .indexes_$ix.index_stemf_$ix <Button-1> {
			set_array_index %W
			determine_coords %W
		}

		# create a label entry for the command
		
		label .indexes_$ix.ix_name_label_$ix \
				-text "Name $ix" \
				-bg grey95 \
				-padx 0
		
		entry .indexes_$ix.ixname_entry_$ix \
				-width 20 \
				-relief sunken \
				-bg white \
				-fg red \
				-textvariable index_name($ix) \
				-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*
		
		label .indexes_$ix.kw_label_$ix \
				-text "Keyw" \
				-bg grey95 \
				-padx 0
		
		entry .indexes_$ix.kw_entry_$ix \
				-width 10 \
				-relief sunken \
				-bg white \
				-fg red \
				-textvariable kw_type($ix) \
				-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*
		
		label .indexes_$ix.gsl_label_$ix \
				-text "GSL" \
				-bg grey95 \
				-padx 0
		
		entry .indexes_$ix.gsl_entry_$ix \
				-width 10 \
				-relief sunken \
				-bg white \
				-fg red \
				-textvariable gsl_file($ix) \
				-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*
		
		label .indexes_$ix.stemf_label_$ix \
				-text "Stem" \
				-bg grey95 \
				-padx 0
		
		entry .indexes_$ix.stemf_entry_$ix \
				-width 10 \
				-relief sunken \
				-bg white \
				-fg red \
				-textvariable stem_fcn($ix) \
				-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*
		
		label .indexes_$ix.flist_label_$ix \
				-text "Fields" \
				-bg grey95 \
				-padx 0
		
		entry .indexes_$ix.flist_entry_$ix \
				-width 20 \
				-relief sunken \
				-bg white \
				-fg red \
				-textvariable field_list($ix) \
				-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-*
		
	}		

	##  6. DB conversion widgets

	frame .db_convert_top_frame \
			-bg grey95 \
			-borderwidth 4

	frame .db_convert_bottom_frame \
			-bg grey95 \
			-borderwidth 4

  text .db_convert_text \
			-wrap "word" \
			-width 30 \
			-height 20 \
			-relief groove \
			-bg White \
			-selectbackground white \
			-selectborderwidth 0 \
			-fg Black \
			-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-* \
			-yscrollcommand ".intro_text_vscroll set"

  scrollbar .db_convert_text_vscroll \
			-command ".db_convert_text yview" \
			-bg Lightgrey \
			-troughcolor SlateGrey \
			-highlightcolor LightGoldenRodYellow

	button .db_convert_button \
			-text "Convert Database" \
			-command "convert_runtime" \
			-relief groove \
			-bd 2 \
			-bg LightGrey \
			-activebackground Red \
			-activeforeground White \
			-disabledforeground Grey60 \
			-state normal

	##  7. Index creation widgets

	frame .create_index_top_frame \
			-bg grey95 \
			-borderwidth 4

	frame .create_index_bottom_frame \
			-bg grey95 \
			-borderwidth 4

  text .create_index_text \
			-wrap "word" \
			-width 30 \
			-height 20 \
			-relief groove \
			-bg White \
			-selectbackground white \
			-selectborderwidth 0 \
			-fg Black \
			-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-* \
			-yscrollcommand ".intro_text_vscroll set"

  scrollbar .create_index_text_vscroll \
			-command ".create_index_text yview" \
			-bg Lightgrey \
			-troughcolor SlateGrey \
			-highlightcolor LightGoldenRodYellow

	button .create_index_button \
			-text "Create Indexes" \
			-command "create_indexes" \
			-relief groove \
			-bd 2 \
			-bg LightGrey \
			-activebackground Red \
			-activeforeground White \
			-disabledforeground Grey60 \
			-state normal

	##  8. Finish Screen

	frame .finish_top_frame \
			-bg grey95 \
			-borderwidth 4

	frame .finish_bottom_frame \
			-bg grey95 \
			-borderwidth 4

  text .finish_text \
			-wrap "word" \
			-width 30 \
			-height 20 \
			-relief groove \
			-bg White \
			-selectbackground white \
			-selectborderwidth 0 \
			-fg Black \
			-font -*-fixed-bold-r-normal--15-140-*-*-*-*-*-* \
			-yscrollcommand ".intro_text_vscroll set"

  scrollbar .finish_text_vscroll \
			-command ".finish_text yview" \
			-bg Lightgrey \
			-troughcolor SlateGrey \
			-highlightcolor LightGoldenRodYellow

  ##  9. The button area at the bottom of the screen, below .left & .right

  frame .main_buttons \
			-bg SlateGray \
			-relief groove \
			-bd 2
	
  button .main_buttons.previous \
			-text "Previous Screen" \
			-relief groove \
			-bd 2 \
			-bg LightGrey \
			-activebackground LightGoldenRodYellow \
			-disabledforeground Grey60 \
			-state normal
	
  button .main_buttons.options \
			-text "Options" \
			-command "post_menu $menu_name $menu_x $menu_y" \
			-relief groove \
			-bd 2 \
			-bg LightGrey \
			-activebackground LightGoldenRodYellow \
			-disabledforeground Grey60 \
			-state normal

	bind .main_buttons.options <Button-1> {
		determine_coords %W
	}
	
  button .main_buttons.next \
			-text "Next Screen" \
			-relief groove \
			-bd 2 \
			-bg LightGrey \
			-activebackground LightGoldenRodYellow \
			-disabledforeground Grey60 \
			-state normal

	##  10. Options menu

	
	menu $menu_name \
			-bg LightGrey \
			-activebackground LightGoldenRodYellow \
			-disabledforeground Grey \
			-bd 1 \
			-font -*-helvetica-medium-r-normal--*-140-*-*-*-*-*-* \
			-tearoff 0
  
	$menu_name add cascade \
			-label "  Set logging level  " \
			-menu $menu_name.logging_level

	menu $menu_name.logging_level \
			-bg LightGrey \
			-fg black \
			-activebackground LightGoldenRodYellow \
			-activeforeground black \
			-disabledforeground grey \
			-bd 1 \
			-font -*-helvetica-medium-r-normal--*-140-*-*-*-*-*-* \
			-tearoff 0
	
	$menu_name.logging_level add radio \
			-label "Full logs" \
			-value "full_history" \
      -command "set_logging_level \"full_history\" $menu_name"
  
	$menu_name.logging_level add radio \
			-label "Indexing commands only" \
			-value "process_history" \
      -command "set_logging_level \"process_history\" $menu_name"
  
	$menu_name add separator

	$menu_name add command \
      -label "  Read Current Parameter File(s)  " \
      -command "read_current_values $menu_name"

	$menu_name add command \
      -label "  Save Current Parameter File(s)  " \
      -command "save_current_values $menu_name"

	$menu_name add separator

	$menu_name add cascade \
      -label "  Load New Parameter File(s)  " \
      -menu $menu_name.params_file_list
		
	menu $menu_name.params_file_list \
			-bg LightGrey \
			-activebackground LightGoldenRodYellow \
			-disabledforeground grey \
			-bd 1 \
			-font -*-helvetica-medium-r-normal--*-140-*-*-*-*-*-* \
      -postcommand "database_list $menu_name.params_file_list" \
			-tearoff 0

	$menu_name add separator
	
	$menu_name add command \
      -label "  Exit  " \
      -command "quit"

	$menu_name add separator
	
	##  Cancel Menu
	##
	
	$menu_name add command \
      -label "  Cancel Menu  " \
      -command "cancel_menu $menu_name"
	
  ##  11. Popup menus for various parameter selection
	##
	##  11.1. DB type selection

	menu $menu_name.set_exch_fname \
			-bg LightGrey \
			-activebackground LightGoldenRodYellow \
			-disabledforeground grey \
			-bd 1 \
			-font -*-helvetica-medium-r-normal--*-140-*-*-*-*-*-* \
      -postcommand "source_data_list $menu_name.set_exch_fname" \
			-tearoff 0

	menu $menu_name.set_db_fname \
			-bg LightGrey \
			-activebackground LightGoldenRodYellow \
			-disabledforeground grey \
			-bd 1 \
			-font -*-helvetica-medium-r-normal--*-140-*-*-*-*-*-* \
      -postcommand "database_list $menu_name.set_db_fname" \
			-tearoff 0

	menu $menu_name.set_dbtype \
			-bg LightGrey \
			-fg black \
			-activebackground LightGoldenRodYellow \
			-activeforeground black \
			-disabledforeground grey \
			-bd 1 \
			-font -*-helvetica-medium-r-normal--*-140-*-*-*-*-*-* \
			-tearoff 0
	
	$menu_name.set_dbtype add radio \
			-label "text" \
			-value "text" \
      -command "set_dbtype text $menu_name"
  
	$menu_name.set_dbtype add radio \
			-label "ai" \
			-value "ai" \
      -command "set_dbtype ai $menu_name"
  
	$menu_name.set_dbtype add radio \
			-label "cat" \
			-value "cat" \
      -command "set_dbtype cat $menu_name"
  
	$menu_name.set_dbtype add separator

	$menu_name.set_dbtype add command \
      -label "Cancel Menu  " \
      -command "cancel_menu $menu_name"
  
	##  11.2. Field type selection

	menu $menu_name.set_ftype \
			-bg LightGrey \
			-fg black \
			-activebackground LightGoldenRodYellow \
			-activeforeground black \
			-disabledforeground grey \
			-bd 1 \
			-font -*-helvetica-medium-r-normal--*-140-*-*-*-*-*-* \
			-tearoff 0
	
	$menu_name.set_ftype add radio \
			-label "Person" \
			-value "Person" \
      -command "set_ftype PERS $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "Corporation" \
			-value "Corporation" \
      -command "set_ftype CORP $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "Names" \
			-value "Names" \
      -command "set_ftype NAMES $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "Title" \
			-value "Title" \
      -command "set_ftype TITLE $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "Main Title" \
			-value "Main Title" \
      -command "set_ftype MAIN_TITLE $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "Sub-Title" \
			-value "Sub-Title" \
      -command "set_ftype SUBTITLE $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "Dewey Number" \
			-value "Dewey Number" \
      -command "set_ftype DEWEY $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "Subject Heading" \
			-value "SH" \
      -command "set_ftype SH $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "Subject Heading (Sub-divn)" \
			-value "SH_SUBDIV" \
      -command "set_ftype SH_SUBDIV $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "Text" \
			-value "TEXT" \
      -command "set_ftype TEXT $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "Phrase" \
			-value "PHRASE" \
      -command "set_ftype PHRASE $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "Literal" \
			-value "LITERAL" \
      -command "set_ftype LITERAL $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "Lowercase Literal" \
			-value "LITERAL_NC" \
      -command "set_ftype LITERAL_NC $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "Numbers" \
			-value "Numbers" \
      -command "set_ftype NUMBERS $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "Year" \
			-value "YEAR" \
      -command "set_ftype YEAR $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "UDC" \
			-value "UDC" \
      -command "set_ftype UDC $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "Any" \
			-value "ANY" \
      -command "set_ftype ANY $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "None" \
			-value "NONE" \
      -command "set_ftype NONE $menu_name"
  
	$menu_name.set_ftype add radio \
			-label "End" \
			-value "END" \
      -command "set_ftype END $menu_name"
  
	$menu_name.set_ftype add separator

	$menu_name.set_ftype add command \
      -label "Cancel Menu  " \
      -command "cancel_menu $menu_name"
  
	##  11.3. Index parameter selection
	##
	##  11.3.1. Keyword

	menu $menu_name.kw \
			-bg LightGrey \
			-fg black \
			-activebackground LightGoldenRodYellow \
			-activeforeground black \
			-disabledforeground grey \
			-bd 1 \
			-font -*-helvetica-medium-r-normal--*-140-*-*-*-*-*-* \
			-tearoff 0
	
	$menu_name.kw add radio \
			-label "words" \
			-value "words3" \
      -command "set_kw_type words3 $menu_name"
  
	$menu_name.kw add radio \
			-label "literal" \
			-value "literal" \
      -command "set_kw_type literal $menu_name"
  
	$menu_name.kw add radio \
			-label "literal lc" \
			-value "literal_nc" \
      -command "set_kw_type literal_nc $menu_name"
  
	$menu_name.kw add radio \
			-label "phrase" \
			-value "phrase" \
      -command "set_kw_type phrase $menu_name"
  
	$menu_name.kw add radio \
			-label "Dewey" \
			-value "Dewey" \
      -command "set_kw_type Dewey $menu_name"
  
	$menu_name.kw add radio \
			-label "Subject heading" \
			-value "subject heading" \
      -command "set_kw_type \"subject heading\" $menu_name"
  
	$menu_name.kw add radio \
			-label "Name Phrase" \
			-value "name_phrase" \
      -command "set_kw_type name_phrase $menu_name"
  
	$menu_name.kw add radio \
			-label "None of these" \
			-value "none of these" \
      -command "set_kw_type none $menu_name"
  
	$menu_name.kw add separator

	$menu_name.kw add command \
      -label "Cancel Menu  " \
      -command "cancel_menu $menu_name"
  
	##  11.3.2. GSL filename

	menu $menu_name.gsl \
			-bg LightGrey \
			-fg black \
			-activebackground LightGoldenRodYellow \
			-activeforeground black \
			-disabledforeground grey \
			-bd 1 \
			-font -*-helvetica-medium-r-normal--*-140-*-*-*-*-*-* \
      -postcommand "gsl_file_list $menu_name.gsl" \
			-tearoff 0
  
	$menu_name.gsl add separator

	$menu_name.gsl add command \
      -label "Cancel Menu  " \
      -command "cancel_menu $menu_name"
  
	##  11.3.3. Stemming function

	menu $menu_name.stem \
			-bg LightGrey \
			-fg black \
			-activebackground LightGoldenRodYellow \
			-activeforeground black \
			-disabledforeground grey \
			-bd 1 \
			-font -*-helvetica-medium-r-normal--*-140-*-*-*-*-*-* \
			-tearoff 0
	
	$menu_name.stem add radio \
			-label "Weak stemming" \
			-value "Weak stemming" \
      -command "set_stemming_function wstem $menu_name"
  
	$menu_name.stem add radio \
			-label "Strong stemming" \
			-value "Strong stemming" \
      -command "set_stemming_function sstem $menu_name"
  
	$menu_name.stem add radio \
			-label "No stemming" \
			-value "No stemming" \
      -command "set_stemming_function nostem $menu_name"
  
	$menu_name.stem add separator

	$menu_name.stem add command \
      -label "Cancel Menu  " \
      -command "cancel_menu $menu_name"
  
	##  Pack universal widgets

	pack .top_header_frame \
				-side top \
				-fill x
		
	pack .top_header_label \
			-in .top_header_frame \
			-side left
		
	pack .upper \
			-side top \
			-fill both \
			-expand true

	pack .lower \
			-side bottom \
			-fill both \
			-expand true
	
	pack .main_buttons \
			-in .lower \
			-side bottom \
			-fill x
	
	bind . <Control-x> "exit"
	
	##  Call the intro_screen procedure

  puts "interface.tcl:: Calling \[proc intro_screen\]"

	intro_screen
}
