/*
**  expand.c
**
**  Reads 'extract_terms' file into termset[]
**  The terms are reweighted when the termset is displayed.
*/

#define G_EXTERN extern

#include "defs.h"

G_EXTERN void show_time(char *, int);
G_EXTERN int ReadTermsetFile(int);
G_EXTERN void current_time(char *);
G_EXTERN void hf_header(int, char *, int);

void expand_query() {
  int t;
  int no_terms;

  char elapsed[RUNTIME_LENGTH];

  /*
  **  Adding new terms to termset so set NEW_ITERATION to TRUE
  */

  NEW_ITERATION = TRUE;
  
  /*
  **  Read termset_file into termset[] since it will
  **  have changed due to extraction of terms from rels.
  **
  **  The terms are sorted into desc rsv order in
  **  display_terms(), defined in 'display.c'
  */

  tf = fopen(termset_file, "r");

  show_time("expand_query", START);

	/*
	**  FALSE indicates that this is not an old query being read in
	*/

  TERM_NO = ReadTermsetFile(FALSE);

  /*
  **  Write history file entry
  */

  current_time(elapsed);

  hf_header(COMMAND_NO, "expand", PARAMS);
  fprintf(hf, ":%d\n", ITERATION_NO);
  fflush(hf);

  EXTRACTED_TERMS = FALSE;

  show_time("expand_query", FINISH);
}
