#include "bss.h"
#include "parms.h"

/*Copyright (c) 2008, City University London
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and
/or other materials provided with the distribution.
    * Neither the name of the City University London nor the names of its contributors may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY D
IRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS O
F USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING N
EGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*****************************************************************************

  bss_globs for BSS perhaps temp Apr 92
  !

*****************************************************************************/

int Pid ;
int Pagesize ;
#ifdef LARGEFILES
int Largefiles = 1 ;		/* True if compiled with large file support
				   (e.g. if Solaris 2.6) */
#else
int Largefiles = 0 ;		/* True if compiled with large file support
				   (e.g. if Solaris 2.6) */
#endif

int silent ;			/* Added March 02 as used by imerge() */
int Maxfiles = MAXFILES ;	/* See bss_startup() (Aug 93) */
int Maxmergestreams = MAXMERGESTREAMS ;	/* (Aug 93) */
int Num_open_files = 0 ;	/* Added May 1993 -- using Jan 96,
				   see bss_fclose() etc */
char *Info_buf ;		/* Used by db_show etc. Malloc'd */

char Username[L_cuserid] ;	/* For user name (cuserid()) */
int Uid ;
int Gid ;
int N_groups ;			/* Actual number of groups for user */
int Groups[NGROUPS_MAX] ;

FILE *stdnothing ;		/* /dev/null */
int stdzero ;			/* fd for /dev/zero, used for mappings */
char *empstr = "" ;
IFN Stem_fns[] = {
   {wstem, "wstem"},
   {nostem, "nostem"},
   {sstem, "sstem"},
   {psstem, "psstem"},
   {(int (*)())NULL, NULL},
} ;

char *Okapi, *BSS ;
char *Control_dir = CONTROL_DIR ;
char *Temp_dir = TEMP_DIR ;
char *Bib_dir = BIB_DIR ;
char *Localbib_dir = LOCALBIB_DIR ;

/******************************************************************************

  Current database and its defaults

******************************************************************************/

char *Db_names ;		/* Buffer for database names */
				/* Feb 98: now allocated by read_db_avail(),
				   reallocd as required */
int Db_num ;			/* Number of available databases for user,
				   the number of pairs of strings in D_names */
Db Cdb ;			/* Single global database for now */

Db *Current_db ;		/* Pointer to (open) current database
				   (needed when more than one db per session)*/
char *Current_db_name ;		/* Pointed to name field of current database.
				   NULL if none open */
char Lim_names[256] ;		/* Buffer for limit names for current db */
int Lim_num ;			/* Number of limit names in Lim_names */
int Current_lim = 0 ;		/* Current limit bit setting */
char *Current_lim_name ;	/* Current limit name (=NULL if none set) */

int Current_ixnum = 0 ;

/* (Nov 99) Don't think the next 3 are used at present */
char Attr_names[256] ;		/* Buffer for search group names for curr db */
int Attr_num ;			/* Number of search group names in Lim_names */
char *Current_Attr_name ;	/* Current search group (=NULL if none set) */

/*****************************************************************************/

Gsl *Gsls[MAXGSLS] ;		/* Global gsls. By default Gsls[0] is the one
				   used in processing free keyword search
				   statements. They should be attached, by
				   name, to indexes (each index may have up
				   to three, each pointing to the appropriate
				   element of Gsls[]).

				   June 97: now (and for some time past)
				   only one per index. Gsls[0] is not
				   special.

				   March 99: now larger (currently 256) array
				   of pointers. */

int Num_gsls ;

/******************************************************************************

  Global BSS set records

******************************************************************************/

Setrec *Setrecs[MAXSETRECS + 1] ; /* The last one is a dummy used when combining
				     sets without saving */
int Num_Setrecs = 0 ;

/******************************************************************************

  Hion and Hioff, vt100, really only for debugging, it's up to an interface
  to do this sort of thing.

******************************************************************************/

char Hion[]  = "\033[7m" ;	
char Hioff[] = "\033[0m" ;


struct hugepos Hpos ;
