/*Copyright (c) 2008, City University London
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and
/or other materials provided with the distribution.
    * Neither the name of the City University London nor the names of its contributors may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY D
IRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS O
F USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING N
EGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef _charclass_h
#define _charclass_h

/******************************************************************************

  charclass.h SW Jan 93

  Character classification on the lines of ctype.h

  Added TOK_PAREN Mar 30 93

******************************************************************************/

#define TOK_IGN 1
#define TOK_START 2
#define TOK_ESTART (TOK_START|TOK_UNDERSCORE)
#define TOK_FIN  4
#define TOK_SPEC 8
#define TOK_APUNCT 0x10
#define TOK_MPUNCT 0x20
#define TOK_STOP 0x40
#define TOK_VOWEL 0x80
#define TOK_CONS 0x100
#define TOK_UPPER 0x200
#define TOK_LOWER 0x400
#define TOK_LSZ 0x800
#define TOK_EILS 0x1000
#define TOK_WXY 0x2000
#define TOK_DIG 0x4000
#define TOK_ALPH (TOK_UPPER|TOK_LOWER)
#define TOK_ALNUM (TOK_DIG|TOK_ALPH)
#define TOK_QUOTE 0x8000
#define TOK_PARENS 0x10000
#define TOK_SPACE 0x20000
#define TOK_CLOSING 0x40000
#define TOK_UNDERSCORE 0x80000
#define TOK_AMPERSAND 0x100000

extern int Toktab[256] ;

#define tok_alnum(c) (Toktab[(unsigned)(c)] & TOK_ALNUM)
#define tok_alpha(c)  (Toktab[(unsigned)(c)] & TOK_ALPH)
#define tok_upper(c)  (Toktab[(unsigned)(c)] & TOK_UPPER)
#define tok_lower(c)  (Toktab[(unsigned)(c)] & TOK_LOWER)
#define tok_digit(c)  (Toktab[(unsigned)(c)] & TOK_DIG)
#define tok_space(c)  (Toktab[(unsigned)(c)] & TOK_SPACE)
#define tok_vowel(c)  (Toktab[(unsigned)(c)] & TOK_VOWEL)

#endif /* _charclass_h */
